[inherit('common')]
module pbdb;

type
   db_ptr = integer;
   cursor_ptr = integer;

[external('db_open')]
function db_open(%STDESCR dbnam : packed array [l1..u1:integer] of char) : db_ptr; extern;

[external('db_sk_put')]
function db_sk_put(%REF db : db_ptr;
                   %STDESCR key : packed array [l2..u2:integer] of char;
                   %IMMED outbuf : INTEGER;
                   %REF outbuflen : integer) : integer; extern;

[external('db_sk_get')]
function db_sk_get(%REF db : db_ptr;
                   %STDESCR key : packed array [l2..u2:integer] of char;
                   %IMMED outbuf : INTEGER;
                   %REF maxoutbuflen : integer;
                   %REF outbuflen : integer) : integer; extern;

[external('db_sk_delete')]
function db_sk_delete(%REF db : db_ptr;
                      %STDESCR key : packed array [l2..u2:integer] of char) : integer; extern;

[external('db_ik_put')]
function db_ik_put(%REF db : db_ptr;
                   %REF key : integer;
                   %IMMED outbuf : INTEGER;
                   %REF outbuflen : integer) : integer; extern;

[external('db_ik_get')]
function db_ik_get(%REF db : db_ptr;
                   %REF key : integer;
                   %IMMED outbuf : INTEGER;
                   %REF maxoutbuflen : integer;
                   %REF outbuflen : integer) : integer; extern;

[external('db_ik_delete')]
function db_ik_delete(%REF db : db_ptr;
                      %REF key : integer) : integer; extern;

[external('db_cursor_open')]
function db_cursor_open(db : db_ptr) : cursor_ptr; extern;

[external('db_cursor_sk_find')]
function db_cursor_sk_find(%REF db : db_ptr;
                           %STDESCR key : packed array [l2..u2:integer] of char;
                           %IMMED outbuf : INTEGER;
                           %REF maxoutbuflen : integer;
                           %REF outbuflen : integer) : integer; extern;

[external('db_cursor_sk_next')]
function db_cursor_sk_next(%REF db : db_ptr;
                           %STDESCR key : packed array [l2..u2:integer] of char;
                           %REF keylen : word;
                           %IMMED outbuf : INTEGER;
                           %REF maxoutbuflen : integer;
                           %REF outbuflen : integer) : integer; extern;

[external('db_cursor_ik_find')]
function db_cursor_ik_find(%REF db : db_ptr;
                           %REF key : integer;
                           %IMMED outbuf : INTEGER;
                           %REF maxoutbuflen : integer;
                           %REF outbuflen : integer) : integer; extern;

[external('db_cursor_ik_next')]
function db_cursor_ik_next(%REF db : db_ptr;
                           %REF key : integer;
                           %IMMED outbuf : INTEGER;
                           %REF maxoutbuflen : integer;
                           %REF outbuflen : integer) : integer; extern;

[external('db_close')]
procedure db_close(%REF db : db_ptr); extern;

end.
