[inherit('common','pbdb')]
program test(input,output);

type
   r = record
          iv : integer;
          sv : varying [50] of char;
       end;

var
   db : db_ptr;
   it : cursor_ptr;
   v, v2 : r;
   k : pstr;
   stat, dummy : integer;

begin
   db := db_open('test.db');
   (* put *)
   v.iv := 123;
   v.sv := 'ABC';
   db_sk_put(db, 'k1', iaddress(v), size(v));
   v.iv := 456;
   v.sv := 'DEF';
   db_sk_put(db, 'k2', iaddress(v), size(v));
   (* get *)
   db_sk_get(db, 'k1', iaddress(v2), size(v2), dummy);
   writeln(v2.iv:1,' ', v2.sv);
   db_sk_get(db, 'k2', iaddress(v2), size(v2), dummy);
   writeln(v2.iv:1,' ', v2.sv);
   (* list all *)
   it := db_cursor_open(db);
   while db_cursor_sk_next(it, k.body, k.length, iaddress(v2), size(v2), dummy) = 0 do begin
      writeln(k, ' ', v2.iv:1,' ', v2.sv);
   end;
   (* list from k1*)
   k := 'k1';
   stat := db_cursor_sk_find(it, fix(k), iaddress(v2), size(v2), dummy);
   while stat = 0 do begin
      writeln(k, ' ', v2.iv:1,' ', v2.sv);
      stat := db_cursor_sk_next(it, k.body, k.length, iaddress(v2), size(v2), dummy);
   end;
   (* list from k2*)
   k := 'k2';
   stat := db_cursor_sk_find(it, fix(k), iaddress(v2), size(v2), dummy);
   while stat = 0 do begin
      writeln(k, ' ', v2.iv:1,' ', v2.sv);
      stat := db_cursor_sk_next(it, k.body, k.length, iaddress(v2), size(v2), dummy);
   end;
   (* delete *)
   k := 'k1';
   db_sk_delete(db, fix(k));
   it := db_cursor_open(db);
   while db_cursor_sk_next(it, k.body, k.length, iaddress(v2), size(v2), dummy) = 0 do begin
      writeln(k, ' ', v2.iv:1,' ', v2.sv);
   end;
   db_close(db);
end.

